import java.util.Hashtable;
import java.util.Vector;

public class Experiment {


	public Experiment() {

	}
	
	public double cl(double totTime, int numLett, double dur, double diff) {
		return diff * dur * numLett / ((dur * numLett) + (((totTime / numLett) - dur)* (numLett -1)));
	}
	
	
	public double difficulty(double dur, double CL, double delay) {
		return ((dur + delay)*CL)/dur;
		
	}
	
	public double duration(int numLett, int numKeys, String PCU) {
		double [][] duration = new double [9][17];

		if(PCU.equals("low")) {
			duration[2][2] = 1.257;
			duration[2][4] = 1.4;
			duration[4][4] = 1.528;
			duration[4][8] = 1.843;
			duration[8][8] = 1.538;
			duration[8][16] = 1.931;
		}
		if(PCU.equals("medium")) {
			duration[2][2] = 1.197;
			duration[2][4] = 1.262;
			duration[4][4] = 1.466;
			duration[4][8] = 1.711;
			duration[8][8] = 1.421;
			duration[8][16] = 1.665;
		}
		if(PCU.equals("high")) {
			duration[2][2] = 1.042;
			duration[2][4] = 1.175;
			duration[4][4] = 1.2;
			duration[4][8] = 1.471;
			duration[8][8] = 1.291;
			duration[8][16] = 1.572;
		}
	    
		
		return duration[numLett][numKeys];
	}
	
	public double difficultyT2(String PCU) {
		if(PCU.equals("low")) {
			return 6;
		}
		if(PCU.equals("medium")) {
			return 6;
		}
		if(PCU.equals("high")) {
			return 6;
		}
		return 0;
	}

	
						
	
	
	// EXPERIMENT 
	public double experiment(int numLett, int numKeys, double totTime, String PCU, boolean criticalityHigh) {
		Simulator s = new Simulator();

		double dur = duration(numLett, numKeys, PCU);
		
		double diff2 = difficultyT2(PCU);
		
		double diff1 = 0.1;
			
		double CL = cl(totTime, numLett, dur, diff2);
		
		double crit1; 
		double crit2 = 0.1;
		
		if(criticalityHigh) {
			crit1 = 40;
		}else {
			crit1 = 4;
		}
	    
        Configuration c = new Configuration();
        Hashtable<Integer, Vector<String>> workingMemory = new Hashtable<Integer, Vector<String>>();
 	    Vector<String> memoryT1 = new Vector<String>(); 


      //TASK2
	   for(int i=0; i< numLett; i++) {
		    Vector<BasicTask> st1 = new Vector<BasicTask>();
		    String info1 = ""+ i;
		    int i2= i + 1;
		    String info2 = "" + i2;
			BasicTask bt1 = new BasicTask(info1, dur, difficulty(dur, CL, ((totTime/numLett)*i)), ((totTime/numLett)*i), info2); 
			st1.add(bt1);
			Subtask subt1 = new Subtask(st1);
			Vector<Subtask> stSeq1 = new Vector<Subtask>();
	        stSeq1.add(subt1);
	 	    Task t1 = new Task(i+1, stSeq1, crit2, 0, "ongoing");
	        workingMemory.put(t1.taskId, memoryT1);
	        c.conf.add(t1);
        
	   }
       memoryT1.add("0");

	   
	   
	   //TASK 1 critical
	   Vector<BasicTask> st2 = new Vector<BasicTask>();
	   for(int j=0; j<20; j++) {
			BasicTask bt2 = new BasicTask("go", 1, diff1, 0, "go"); st2.add(bt2);
	   }
		
	   Subtask subt2 = new Subtask(st2);
       Vector<Subtask> stSeq2 = new Vector<Subtask>();
       stSeq2.add(subt2);
       Task t2 = new Task(numLett + 1, stSeq2, crit1, 0, "ongoing");
        
       Vector<String> memoryT2 = new Vector<String>(); 
       memoryT2.add("go");
       
       workingMemory.put(t2.taskId, memoryT2);

       WorkingMemory wm = new WorkingMemory(workingMemory, 9);
       
       c.conf.add(t2);
       
       c.workingMemory = wm;
		
	   return s.simulate(c);

	
	   
	   
	}
	
	
	public void exp1() {
		
		Experiment exp = new Experiment();

		double sum2=0;
		sum2 += exp.experiment(2,2,18,"low", false);
		sum2 += exp.experiment(2,2,22,"low", false);
		sum2 += exp.experiment(2,2,26,"low", false);
		
		sum2 += exp.experiment(2,4,18,"low", false);
		sum2 += exp.experiment(2,4,22,"low", false);
		sum2 += exp.experiment(2,4,26,"low", false);
		
		sum2 += exp.experiment(4,4,18,"low", false);
		sum2 += exp.experiment(4,4,22,"low", false);
		sum2 += exp.experiment(4,4,26,"low", false);
		
		sum2 += exp.experiment(4,8,18,"low", false);
		sum2 += exp.experiment(4,8,22,"low", false);
		sum2 += exp.experiment(4,8,26,"low", false);
		
		sum2 += exp.experiment(8,8,18,"low", false);
		sum2 += exp.experiment(8,8,22,"low", false);
		sum2 += exp.experiment(8,8,26,"low", false);
		
		sum2 += exp.experiment(8,16,18,"low", false);
		sum2 += exp.experiment(8,16,22,"low", false);
		sum2 += exp.experiment(8,16,26,"low", false);

		System.out.println("LOW PCU LOW CRITICALITY");
		System.out.println("Average max wait time " + sum2/18);
	}
	
	public void exp2() {
		
		Experiment exp = new Experiment();

		double sum2=0;
		sum2 += exp.experiment(2,2,18,"low", true);
		sum2 += exp.experiment(2,2,22,"low", true);
		sum2 += exp.experiment(2,2,26,"low", true);
		
		sum2 += exp.experiment(2,4,18,"low", true);
		sum2 += exp.experiment(2,4,22,"low", true);
		sum2 += exp.experiment(2,4,26,"low", true);
		
		sum2 += exp.experiment(4,4,18,"low", true);
		sum2 += exp.experiment(4,4,22,"low", true);
		sum2 += exp.experiment(4,4,26,"low", true);
		
		sum2 += exp.experiment(4,8,18,"low", true);
		sum2 += exp.experiment(4,8,22,"low", true);
		sum2 += exp.experiment(4,8,26,"low", true);
		
		sum2 += exp.experiment(8,8,18,"low", true);
		sum2 += exp.experiment(8,8,22,"low", true);
		sum2 += exp.experiment(8,8,26,"low", true);
		
		sum2 += exp.experiment(8,16,18,"low", true);
		sum2 += exp.experiment(8,16,22,"low", true);
		sum2 += exp.experiment(8,16,26,"low", true);

		System.out.println("LOW PCU HIGH CRITICALITY");
		System.out.println("Average max wait time " + sum2/18);
	}
	
	public void exp3() {
		
		Experiment exp = new Experiment();

		double sum2=0;
		sum2 += exp.experiment(2,2,18,"medium", false);
		sum2 += exp.experiment(2,2,22,"medium", false);
		sum2 += exp.experiment(2,2,26,"medium", false);
		
		sum2 += exp.experiment(2,4,18,"medium", false);
		sum2 += exp.experiment(2,4,22,"medium", false);
		sum2 += exp.experiment(2,4,26,"medium", false);
		
		sum2 += exp.experiment(4,4,18,"medium", false);
		sum2 += exp.experiment(4,4,22,"medium", false);
		sum2 += exp.experiment(4,4,26,"medium", false);
		
		sum2 += exp.experiment(4,8,18,"medium", false);
		sum2 += exp.experiment(4,8,22,"medium", false);
		sum2 += exp.experiment(4,8,26,"medium", false);
		
		sum2 += exp.experiment(8,8,18,"medium", false);
		sum2 += exp.experiment(8,8,22,"medium", false);
		sum2 += exp.experiment(8,8,26,"medium", false);
		
		sum2 += exp.experiment(8,16,18,"medium", false);
		sum2 += exp.experiment(8,16,22,"medium", false);
		sum2 += exp.experiment(8,16,26,"medium", false);
			
		System.out.println("MEDIUM PCU LOW CRITICALITY");
		System.out.println("Average max wait time " + sum2/18);
	}
	
	public void exp4() {
		
		Experiment exp = new Experiment();

		double sum2=0;
		sum2 += exp.experiment(2,2,18,"medium", true);
		sum2 += exp.experiment(2,2,22,"medium", true);
		sum2 += exp.experiment(2,2,26,"medium", true);
		
		sum2 += exp.experiment(2,4,18,"medium", true);
		sum2 += exp.experiment(2,4,22,"medium", true);
		sum2 += exp.experiment(2,4,26,"medium", true);
		
		sum2 += exp.experiment(4,4,18,"medium", true);
		sum2 += exp.experiment(4,4,22,"medium", true);
		sum2 += exp.experiment(4,4,26,"medium", true);
		
		sum2 += exp.experiment(4,8,18,"medium", true);
		sum2 += exp.experiment(4,8,22,"medium", true);
		sum2 += exp.experiment(4,8,26,"medium", true);
		
		sum2 += exp.experiment(8,8,18,"medium", true);
		sum2 += exp.experiment(8,8,22,"medium", true);
		sum2 += exp.experiment(8,8,26,"medium", true);
		
		sum2 += exp.experiment(8,16,18,"medium", true);
		sum2 += exp.experiment(8,16,22,"medium", true);
		sum2 += exp.experiment(8,16,26,"medium", true);

		System.out.println("MEDIUM PCU HIGH CRITICALITY");
		System.out.println("Average max wait time " + sum2/18);
	}
	
	public void exp5() {
		
		Experiment exp = new Experiment();

		double sum2=0;
		sum2 += exp.experiment(2,2,18,"high", false);
		sum2 += exp.experiment(2,2,22,"high", false);
		sum2 += exp.experiment(2,2,26,"high", false);
		
		sum2 += exp.experiment(2,4,18,"high", false);
		sum2 += exp.experiment(2,4,22,"high", false);
		sum2 += exp.experiment(2,4,26,"high", false);
		
		sum2 += exp.experiment(4,4,18,"high", false);
		sum2 += exp.experiment(4,4,22,"high", false);
		sum2 += exp.experiment(4,4,26,"high", false);
		
		sum2 += exp.experiment(4,8,18,"high", false);
		sum2 += exp.experiment(4,8,22,"high", false);
		sum2 += exp.experiment(4,8,26,"high", false);
		
		sum2 += exp.experiment(8,8,18,"high", false);
		sum2 += exp.experiment(8,8,22,"high", false);
		sum2 += exp.experiment(8,8,26,"high", false);
		
		sum2 += exp.experiment(8,16,18,"high", false);
		sum2 += exp.experiment(8,16,22,"high", false);
		sum2 += exp.experiment(8,16,26,"high", false);
	
		System.out.println("HIGH PCU LOW CRITICALITY");
		System.out.println("Average max wait time " + sum2/18);
}
	public void exp6() {
		
		Experiment exp = new Experiment();
		double sum2=0;
	
		sum2 += exp.experiment(2,2,18,"high", true);
		sum2 += exp.experiment(2,2,22,"high", true);
		sum2 += exp.experiment(2,2,26,"high", true);
		
		sum2 += exp.experiment(2,4,18,"high", true);
		sum2 += exp.experiment(2,4,22,"high", true);
		sum2 += exp.experiment(2,4,26,"high", true);
		
		sum2 += exp.experiment(4,4,18,"high", true);
		sum2 += exp.experiment(4,4,22,"high", true);
		sum2 += exp.experiment(4,4,26,"high", true);
		
		sum2 += exp.experiment(4,8,18,"high", true);
		sum2 += exp.experiment(4,8,22,"high", true);
		sum2 += exp.experiment(4,8,26,"high", true);
		
		sum2 += exp.experiment(8,8,18,"high", true);
		sum2 += exp.experiment(8,8,22,"high", true);
		sum2 += exp.experiment(8,8,26,"high", true);
		
		sum2 += exp.experiment(8,16,18,"high", true);
		sum2 += exp.experiment(8,16,22,"high", true);
		sum2 += exp.experiment(8,16,26,"high", true);
		System.out.println("HIGH PCU HIGH CRITICALITY");
		System.out.println("Average max wait time " + sum2/18);
	}

		public static void main(String[] args){
			Experiment exp = new Experiment();
			
			exp.exp1();
			exp.exp2();
			exp.exp3();
			exp.exp4();
			exp.exp5();
			exp.exp6();
			
		}
	}
	
	
	

