import java.util.*;
public class Task {
	
	int taskId;
	Vector<Subtask> stSequence = new Vector<Subtask>();
	double criticality;
	double timeStamp;     //last time the task has been executed
	double cognitiveLoad;
	String status;
	//"ongoing" if everything is going well, 
	//"completed" when the task is completed (updated in simulator)
	//"interrupted" when some information is deleted but the task is not completed (updated in overload(), in configuration)

	public Task(int taskId, Vector<Subtask> stSequence, double criticality, double timeStamp, String status) {
		this.taskId=taskId;
		this.stSequence=stSequence;
		this.criticality=criticality;
		this.timeStamp=timeStamp;		
		this.cognitiveLoad = stSequence.get(0).cognitiveLoad();
		this.status="ongoing";   
	}
	
	//remove vector if it is empty and update the cognitive load if it is necessary
	public void update() {
		stSequence.remove(0);
		cognitiveLoad = (stSequence.size()==0 ? 0 : stSequence.get(0).cognitiveLoad());
	}
	
	//alpha returns the alpha factor of the task
	public double alpha() {
		double alpha=0;
		double wt= Configuration.globalClock - timeStamp -hd().delay;
		alpha= criticality * (wt + 1) * cognitiveLoad;
		return alpha;
	}
	
	//method hd returns first basic task of task
	public BasicTask hd(){
		if(stSequence.size()==0){    
			return null;
		}
		return stSequence.get(0).basicTaskSequence.firstElement();
	}
	
	//method tl deletes the first element in the vector of BASICTASK
	public void tl(){
		stSequence.get(0).basicTaskSequence.remove(0);
	}
	
	//return true if the task is completed, false otherwise
	public boolean completed(){
		if(stSequence.size()==0){
			return true;
		}else{
			return false;
		}
	}
	
	
}